sink.text.details: add `with-data` initialization parameter
[babeltrace.git] / tests / utils / utils.sh
index a2a5c1dd966787ceadd232e4aa340f75f6c0899f..04b45203a69b411047fef6af868c40144da8623b 100644 (file)
@@ -85,20 +85,12 @@ if [ "x${BT_TESTS_BT2_BIN:-}" = "x" ]; then
 fi
 export BT_TESTS_BT2_BIN
 
-if [ "x${BT_TESTS_BT2LOG_BIN:-}" = "x" ]; then
-       BT_TESTS_BT2LOG_BIN="$BT_TESTS_BUILDDIR/../src/cli/babeltrace2-log"
-       if [ "$BT_OS_TYPE" = "mingw" ]; then
-               BT_TESTS_BT2LOG_BIN="${BT_TESTS_BT2LOG_BIN}.exe"
-       fi
-fi
-export BT_TESTS_BT2LOG_BIN
-
 # TODO: Remove when bindings/python/bt2/test_plugin.py is fixed
 BT_PLUGINS_PATH="${BT_TESTS_BUILDDIR}/../src/plugins"
 
 # Allow overriding the babeltrace2 plugin path
 if [ "x${BT_TESTS_BABELTRACE_PLUGIN_PATH:-}" = "x" ]; then
-       BT_TESTS_BABELTRACE_PLUGIN_PATH="${BT_PLUGINS_PATH}/ctf:${BT_PLUGINS_PATH}/utils:${BT_PLUGINS_PATH}/text"
+       BT_TESTS_BABELTRACE_PLUGIN_PATH="${BT_PLUGINS_PATH}/ctf:${BT_PLUGINS_PATH}/utils:${BT_PLUGINS_PATH}/text:${BT_PLUGINS_PATH}/lttng-utils"
 fi
 
 if [ "x${BT_TESTS_PROVIDER_DIR:-}" = "x" ]; then
@@ -142,56 +134,50 @@ export BT_TESTS_SED_BIN
 BT_TESTS_DATADIR="${BT_TESTS_SRCDIR}/data"
 BT_CTF_TRACES_PATH="${BT_TESTS_DATADIR}/ctf-traces"
 
+# Run the Babeltrace CLI, redirecting stdout and stderr to specified files.
+#
+#   $1: file to redirect stdout to
+#   $2: file to redirect stderr to
+#   remaining args: arguments to pass to the CLI
+#
+# Return the exit code of the CLI.
+
+bt_cli() {
+       local stdout_file="$1"
+       local stderr_file="$2"
+       shift 2
+       local args=("$@")
+
+       echo "Running: $BT_TESTS_BT2_BIN ${args[*]}" >&2
+       run_python_bt2 "$BT_TESTS_BT2_BIN" "${args[@]}" 1>"$stdout_file" 2>"$stderr_file"
+}
 
 ### Diff Functions ###
 
-# Checks the difference between stdout:
-#
-#   The file with path "$1", and the file with path "$2"
+# Check the differences between two files (typically some expected output vs
+# some actual output).  If there are differences, print the diff to stderr.
 #
-# And the difference between stderr:
+#   $1: file 1 (expected)
+#   $2: file 2 (actual)
 #
-#   The file with path "$3", and the file with path "$4"
+# Return 0 if there's no difference, and non-zero if there are.
 #
-# Returns 0 if there's no difference, and 1 if there is, also printing
-# said difference to the standard error, and an error message with the
-# args starting at "$5".
-bt_diff() {
-       local expected_stdout_file="$1"
-       local actual_stdout_file="$2"
-       local expected_stderr_file="$3"
-       local actual_stderr_file="$4"
-       shift 4
-       local args=("$@")
+# Note that this function modifies the actual output file ($2) _in-place_ to
+# remove any \r character.
 
+bt_diff() {
+       local expected_file="$1"
+       local actual_file="$2"
        local ret=0
-       local temp_diff
-
-       temp_diff="$(mktemp -t diff.XXXXXX)"
 
        # Strip any \r present due to Windows (\n -> \r\n).
        # "diff --string-trailing-cr" is not used since it is not present on
        # Solaris.
-       "$BT_TESTS_SED_BIN" -i 's/\r//g' "$actual_stdout_file"
-       "$BT_TESTS_SED_BIN" -i 's/\r//g' "$actual_stderr_file"
-
-       # Compare stdout output with expected stdout output
-       if ! diff -u "$actual_stdout_file" "$expected_stdout_file" 2>/dev/null >"$temp_diff"; then
-               echo "ERROR: for '${args[*]}': actual standard output and expected output differ:" >&2
-               cat "$temp_diff" >&2
-               ret=1
-       fi
-
-       # Compare stderr output with expected stderr output
-       if ! diff -u "$actual_stderr_file" "$expected_stderr_file" 2>/dev/null >"$temp_diff"; then
-               echo "ERROR: for '${args[*]}': actual standard error and expected error differ:" >&2
-               cat "$temp_diff" >&2
-               ret=1
-       fi
+       "$BT_TESTS_SED_BIN" -i 's/\r//g' "$actual_file"
 
-       rm -f "$temp_diff"
+       diff -u "$expected_file" "$actual_file" 1>&2
 
-       return $ret
+       return $?
 }
 
 # Checks the difference between:
@@ -217,57 +203,23 @@ bt_diff_cli() {
        local temp_stdout_output_file
        local temp_stderr_output_file
        local ret=0
+       local ret_stdout
+       local ret_stderr
 
        temp_stdout_output_file="$(mktemp -t actual_stdout.XXXXXX)"
        temp_stderr_output_file="$(mktemp -t actual_stderr.XXXXXX)"
 
        # Run the CLI to get a detailed file.
-       run_python_bt2 "$BT_TESTS_BT2_BIN" "${args[@]}" 1>"$temp_stdout_output_file" 2>"$temp_stderr_output_file"
-
-       bt_diff "$expected_stdout_file" "$temp_stdout_output_file" "$expected_stderr_file" "$temp_stderr_output_file" "${args[@]}"
-       ret=$?
-
-       rm -f "$temp_stdout_output_file" "$temp_stderr_output_file"
-
-       return $ret
-}
-
-# Checks the difference between:
-#
-#   1. What the CLI outputs on its standard output when given the arguments
-#   "$@" (excluding the first two arguments), sorted with the default "sort".
-#   2. The file with path "$1".
-#
-# And the difference between:
-#
-#   1. What the CLI outputs on its standard error when given the arguments
-#   "$@" (excluding the first two arguments).
-#   2. The file with path "$2".
-#
-# Returns 0 if there's no difference, and 1 if there is, also printing
-# said difference to the standard error.
-bt_diff_cli_sorted() {
-       local expected_stdout_file="$1"
-       local expected_stderr_file="$2"
-       shift 2
-       local args=("$@")
-
-       local temp_stdout_output_file
-       local temp_stderr_output_file
-       local ret=0
-
-       temp_stdout_output_file="$(mktemp -t actual_stdout.XXXXXX)"
-       temp_stderr_output_file="$(mktemp -t actual_stderr.XXXXXX)"
-
-       # Run the CLI to get a detailed file.
-       run_python_bt2 "$BT_TESTS_BT2_BIN" "${args[@]}" 1>"$temp_stdout_output_file" 2>"$temp_stderr_output_file"
+       bt_cli "$temp_stdout_output_file" "$temp_stderr_output_file" "${args[@]}"
 
-       # Sort the stdout file, use a subshell to do it in-place
-       # shellcheck disable=SC2005
-       echo "$(LC_ALL=C sort "$temp_stdout_output_file")" > "$temp_stdout_output_file"
+       bt_diff "$expected_stdout_file" "$temp_stdout_output_file" "${args[@]}"
+       ret_stdout=$?
+       bt_diff "$expected_stderr_file" "$temp_stderr_output_file" "${args[@]}"
+       ret_stderr=$?
 
-       bt_diff "$expected_stdout_file" "$temp_stdout_output_file" "$expected_stderr_file" "$temp_stderr_output_file" "${args[@]}"
-       ret=$?
+       if ((ret_stdout != 0 || ret_stderr != 0)); then
+               ret=1
+       fi
 
        rm -f "$temp_stdout_output_file" "$temp_stderr_output_file"
 
@@ -337,6 +289,7 @@ run_python_bt2() {
                "BABELTRACE_PYTHON_BT2_NO_TRACEBACK=1" \
                "BABELTRACE_PLUGIN_PATH=${BT_TESTS_BABELTRACE_PLUGIN_PATH}" \
                "LIBBABELTRACE2_PLUGIN_PROVIDER_DIR=${BT_TESTS_PROVIDER_DIR}" \
+               "BT_TESTS_DATADIR=${BT_TESTS_DATADIR}" \
                "BT_CTF_TRACES_PATH=${BT_CTF_TRACES_PATH}" \
                "BT_PLUGINS_PATH=${BT_PLUGINS_PATH}" \
                "PYTHONPATH=${BT_TESTS_PYTHONPATH}:${BT_TESTS_SRCDIR}/utils/python"
This page took 0.025893 seconds and 4 git commands to generate.